
function sendRequest(requestBody, requestUrl, successFunc, loadingStr,type) {
	if (loadingStr == null || loadingStr == "") {
		loadingStr = "读取数据中...";
	}
	if(type == null|| type==""){
		type = "post";
	}
	plus.nativeUI.showWaiting(loadingStr);
	var requestHeader = {
		"phone_OS" : getPhoneOS(),
		"phone_OS_ver" : getPhoneOSVer(),
		"phone_OS_ID" : getPhoneOSID(),
		"seq_no" : Math.uuid(32),
		"client_version" : version,
		"login_name" : PermanentCache.getItem("login_name")
	};
	jsonmessage.requestHeader = requestHeader;
	jsonmessage.requestBody = requestBody;
	plog("地址："+baseUrl + requestUrl);
	mui.ajax(baseUrl + requestUrl,{
		data:{
			msg: jsonToStr(jsonmessage)
		},
		dataType:"json",//服务器返回json格式数据
		type:type,//HTTP请求类型
		timeout:outsecond,//超时时间;
		success:function(json){
			plus.nativeUI.closeWaiting();
			if (json.header.return_code == "true") {
				// 调用请求成功的回调函数
				successFunc(json);
			} else {
				// 获取失败
				mui.alert(json.header.errorMsg,"友情提示");
			}
		},
		error:function(xhr,type,errorThrown){
			//异常处理；
			plus.nativeUI.closeWaiting();
			plog("失败");
			plog(xhr);
			plog("a:" + type);
			plog("b:" + errorThrown);
			mui.alert("服务器升级中...","友情提示");
		}
	});
}
function sendRequest2(requestBody, requestUrl, successFunc, loadingStr,type) {
	
	var requestHeader = {
		"phone_OS" : getPhoneOS(),
		"phone_OS_ver" : getPhoneOSVer(),
		"phone_OS_ID" : getPhoneOSID(),
		"seq_no" : Math.uuid(32),
		"client_version" : version,
		"login_name" : PermanentCache.getItem("login_name")
	};
	jsonmessage.requestHeader = requestHeader;
	jsonmessage.requestBody = requestBody;
	plog("地址："+baseUrl + requestUrl);
	mui.ajax(baseUrl + requestUrl,{
		data:{
			msg: jsonToStr(jsonmessage)
		},
		dataType:"json",//服务器返回json格式数据
		type:type,//HTTP请求类型
		timeout:outsecond,//超时时间;
		success:function(json){
			plus.nativeUI.closeWaiting();
			if (json.header.return_code == "true") {
				// 调用请求成功的回调函数
				successFunc(json);
			} else {
				// 获取失败
				mui.alert(json.header.errorMsg,"友情提示");
			}
		},
		error:function(xhr,type,errorThrown){
			//异常处理；
			plus.nativeUI.closeWaiting();
			plog("失败");
			plog(xhr);
			plog("a:" + type);
			plog("b:" + errorThrown);
			mui.alert("服务器升级中...","友情提示");
		}
	});
}

/**
 * 统一的红字信息提示：针对的是mobile的登录和填写意见时的提示.
 * @param mesDivId 提示信息作用的区域
 * @param mes 提示信息
 */
function toAlertMessage(mesDivId, msg) {
	var content = "";
	content = "<h2>" + msg + "</h2>";
	jQuery("#" + mesDivId).html(msg);
	jQuery("#" + mesDivId).show();
	//6秒钟后隐藏提示区域
	setTimeout(function() {
		var content = "";
		jQuery("#" + mesDivId).html(content);
		jQuery("#" + mesDivId).hide();
	}, 6000);
}

// ------------------------ 字符串处理 ------------------------
/**
 * 字符串格式化
 * 使用方法：
 * （1）需格式化的字符串：var str = "格式化{0}个字符，成功{1}个";
 * （2）调用：String.format(str,第一个参数对应{0}, 第二个参数对应{1})
 * @returns {*}
 */
String.format = function() {
	var theString = arguments[0];

	for (var i = 1; i < arguments.length; i++) {
		var regEx = new RegExp("\\{" + (i - 1) + "\\}", "gm");
		theString = theString.replace(regEx, arguments[i]);
	}

	return theString;
}

/**
 * 将Json对象转为字符串
 * @param json Json对象
 */
function jsonToStr(json) {
	return JSON.stringify(json);
}

/**
 * 将json格式的字符串转为Json对象
 * @param str json格式的字符串
 */
function strToJson(str) {
	return JSON.parse(str);
}

/**
 * 处理空字符串，避免其显示为undefined
 * @param str
 * @returns {*}
 */
function undefinedHandler(str) {
	if (str == null) {
		return "";
	}
	return str;
}

/**
 * 移除开头和结尾的一个字符
 * @param string
 * @param char 要去掉的字符
 * @returns {*}
 */
function removeFirstLastChar(string, char) {
	var str = string;
	if (!Validator.isEmail(str)) {
		if (str.substr(0, 1) == char) {
			str = str.substr(1);
		}

		if (str.substr(str.length - 1, str.length) == char) {
			str = str.substr(0, str.length - 1);
		}
	}
	return str;
}

// ------------------------ 密码加密相关 ------------------------
/**
 *加密
 * MD5(sha1(loginName)+sha256(password+key))
 */
function encryp(loginName, passwd) {
	var key = "EF1E4DDC8A657B4F67349B8635ECBA07";

	// new MD5 instance
	var MD5 = new Hashes.MD5;
	//	 // new SHA1 instance
	var SHA1 = new Hashes.SHA1;
	//	 // new SHA256 instance
	var SHA256 = new Hashes.SHA256;

	var ln = SHA1.hex(loginName);
	var pw = SHA256.hex(passwd + key);
	return MD5.hex(ln + pw);
}

// ------------------------ 设备操作系统相关 ------------------------
/**
 * 取得设备操作系统类型
 * @returns 1:iOS 2:android
 */
function getPhoneOS() {
	if (plus.os.name == "iOS") {
		//alert("苹果手机");
		return "iOS";
	} else if (plus.os.name == "Android") {
		//alert("安卓手机");
		return "Android";
	} else {
		//alert("其他手机");
		return "other";
	}
}

/**
 * 取得设备操作系统版本
 * @returns 
 */
function getPhoneOSVer() {
	return plus.os.version;
}
/**
 * 取得设备编号
 * @returns 
 */
function getPhoneOSID() {
	return plus.device.uuid;
}
/**
 * 取得流水号
 * @returns 
 */
function getSeqNo() {

}

// ------------------------ 设备硬件相关 ------------------------
/**
 * 取得设备屏幕宽度
 * @returns {*|jQuery}
 */
function getDeviceWidth() {
	return jQuery(window).width();
}

// ------------------------ 其他公共方法 ------------------------
/**
 * 检测数据是否为空并获取焦点
 * @param id 数据的id
 * @param msg 提示信息
 * @param tipId 提示生成区域id
 * @return
 */
function checkDataIsNull(id, msg, tipId) {
	var resultVal = jQuery("#" + id).val();
	if (resultVal == '' || resultVal == null) {
		toAlertMessage(tipId, msg);
		jQuery("#" + id).focus();
		return false;
	}
	return true;
}

/**
 * 检测数据是否相同并获取焦点
 * @param id1 数据的id1
 * @param id2 数据的id2
 * @param msg 提示信息
 * @param tipId 提示生成区域id
 * @return
 */
function checkDataIsEqual(id1,id2, msg, tipId) {
	var resultVal1 = jQuery("#" + id1).val();
	var resultVal2 = jQuery("#" + id2).val();
	if (resultVal1 != resultVal2) {
		toAlertMessage(tipId, msg);
		jQuery("#" + id1).focus();
		return false;
	}
	return true;
}

/**
 * 检测数据合法性并获取焦点
 * @param regModel 正则模板
 * @param data 需要校验的数据
 * @param msg 提示信息
 * @param tipId 提示生成区域id
 * @return
 */
function checkData(regModel, id, msg, tipId) {
	var reg = new RegExp(regModel);
	var data = jQuery("#" + id).val();
	var result = reg.test(data);
	if (result == false) {
		toAlertMessage(tipId, msg);
		jQuery("#" + id).focus();
		return false;
	}
	return true;
}

/**
 * 获取当前时间
 */
//补齐两位数
function padleft0(obj) {
	return obj.toString().replace(/^[0-9]{1}$/, "0" + obj);
}
//格式2016-03-10 11:32:32
function getnowtime() {
	var nowtime = new Date();
	var year = nowtime.getFullYear();
	var month = padleft0(nowtime.getMonth() + 1);
	var day = padleft0(nowtime.getDate());
	var hour = padleft0(nowtime.getHours());
	var minute = padleft0(nowtime.getMinutes());
	var second = padleft0(nowtime.getSeconds());
	var result = year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second;
	return result;
}

/**
 * 打印日志（在constant.js中控制开关）
 * @param log
 */
function plog(log) {
	if (isPrintLog) {
		console.log(log);
	}
}

function checkSucc(json) {
	TempStorage.setItem("usercode", json.package.body.userid)
}

/*
 * Generate a random uuid.
 *
 * USAGE: Math.uuid(length, radix)
 *   length - the desired number of characters
 *   radix  - the number of allowable values for each character.
 *
 * EXAMPLES:
 *   // No arguments  - returns RFC4122, version 4 ID
 *   >>> Math.uuid()
 *   "92329D39-6F5C-4520-ABFC-AAB64544E172"
 *
 *   // One argument - returns ID of the specified length
 *   >>> Math.uuid(15)     // 15 character ID (default base=62)
 *   "VcydxgltxrVZSTV"
 *
 *   // Two arguments - returns ID of the specified length, and radix. (Radix must be <= 62)
 *   >>> Math.uuid(8, 2)  // 8 character ID (base=2)
 *   "01001010"
 *   >>> Math.uuid(8, 10) // 8 character ID (base=10)
 *   "47473046"
 *   >>> Math.uuid(8, 16) // 8 character ID (base=16)
 *   "098F4D35"
 */
(function() {
	// Private array of chars to use
	var CHARS = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');

	Math.uuid = function(len, radix) {
		var chars = CHARS,
			uuid = [],
			i;
		radix = radix || chars.length;

		if (len) {
			// Compact form
			for (i = 0; i < len; i++) uuid[i] = chars[0 | Math.random() * radix];
		} else {
			// rfc4122, version 4 form
			var r;

			// rfc4122 requires these characters
			uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
			uuid[14] = '4';

			// Fill in random data.  At i==19 set the high bits of clock sequence as
			// per rfc4122, sec. 4.1.5
			for (i = 0; i < 36; i++) {
				if (!uuid[i]) {
					r = 0 | Math.random() * 16;
					uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
				}
			}
		}
		var lastID = "";
		var uuArray = uuid.join('').split('-');
		for (var i = 0; i < uuArray.length; i++) {
			lastID += uuArray[i];
		}
		return lastID;
	};

	// A more performant, but slightly bulkier, RFC4122v4 solution.  We boost performance
	// by minimizing calls to random()
	Math.uuidFast = function() {
		var chars = CHARS,
			uuid = new Array(36),
			rnd = 0,
			r;
		for (var i = 0; i < 36; i++) {
			if (i == 8 || i == 13 || i == 18 || i == 23) {
				uuid[i] = '-';
			} else if (i == 14) {
				uuid[i] = '4';
			} else {
				if (rnd <= 0x02) rnd = 0x2000000 + (Math.random() * 0x1000000) | 0;
				r = rnd & 0xf;
				rnd = rnd >> 4;
				uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
			}
		}
		return uuid.join('');
	};

	// A more compact, but less performant, RFC4122v4 solution:
	Math.uuidCompact = function() {
		return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
			var r = Math.random() * 16 | 0,
				v = c == 'x' ? r : (r & 0x3 | 0x8);
			return v.toString(16);
		});
	};
})();